 
REM MARIAJOSE GESTIO_ESTADISTICA

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."GESTIO_ESTADISTICA" ( procediment VARCHAR2, 
                  
                     v_idvotacio votacio.IDVOTACIO%TYPE,
                     v_idcens cens.IDCENS%TYPE, 
               
                    rsp OUT  VARCHAR2) IS
   
   textLog VARCHAR2(255 CHAR);
   V_ANYO NUMBER;
   V_IDVOTACIOMAJORP NUMBER;
   V_PERCENTATGE_ANTERIOR NUMBER;  
   V_PERCENTATGE_VOTACIO_ACTUAL NUMBER;  
   V_HAYFILA NUMBER;  
   V_LOCALITAT_MES_VOTADA VARCHAR2(255);
   V_CIUTADANS_ANY NUMBER;
   V_CIUTADANS_ANY_SI NUMBER;
   V_ESTAT VARCHAR2(2);
   V_VOTACIONS_PERSONA NUMBER;
   
    BEGIN
        BEGIN
             
        
     --NOMBRE DE VOTACIONS FINALITZADES QUE S'HAN PRODUIT EN UN PAIS I ANY
     
            IF procediment= 'MODIFICAVOTACIO' Or
               procediment= 'ALTAVOTACIO_CENS' or
               procediment= 'BAIXAVOTACIO_CENS' 
            THEN 
            
                DELETE FROM E_VOTACIONS_ANY_PAIS;
                
                INSERT INTO E_VOTACIONS_ANY_PAIS (
                 SELECT 
                 EXTRACT (YEAR FROM DATAINICI), ESTAT, COUNT(*)
                 FROM VOTACIO, CENS, VOTACIO_CENS
                 WHERE IDVOTACIO= VOTACIO_IDVOTACIO 
                    AND CENSASSOCIAT=IDCENS AND
                        TIPUSDECENS= 'estatal' AND
                        ESTATVOTACIO= 'finalitzada'
                 GROUP BY EXTRACT(YEAR FROM DATAINICI),  ESTAT
                        );
                        
               
       --VALOR MITJA DEL PERCENTATGE DE PARTICIPACIO PER CENS I ANY
       
                DELETE FROM E_CENS_ANY;
                
                INSERT INTO E_CENS_ANY ( ANYS, IDE_CENS, VALORMIGPARTICIP) (
                 SELECT 
                 EXTRACT (YEAR FROM DATAFI), IDCENS, AVG(PARTICIPACIO)
                 FROM VOTACIO, CENS, VOTACIO_CENS
                 WHERE IDVOTACIO= VOTACIO_IDVOTACIO 
                    AND CENSASSOCIAT=IDCENS AND
                    ESTATVOTACIO= 'finalitzada'
                 GROUP BY EXTRACT(YEAR FROM DATAFI),  IDCENS
                        );
               
            END IF;  
            
            
     -- VOTACIONS ASSOCIADES A UN CENS I UN ANY        
            
            IF procediment='ALTAVOTACIO_CENS' THEN 
            
             
               UPDATE E_CENS_ANY_2 SET NOMBREVOTACIONSASSOCIADES=NOMBREVOTACIONSASSOCIADES+1
               WHERE IDE_CENS =v_idcens AND
                     ANYS= (SELECT EXTRACT (YEAR FROM DATAINICI) FROM VOTACIO WHERE IDVOTACIO=V_IDVOTACIO);
               IF sql%rowcount = 0 then 
               /*si encara no hi ha fila la creem */
               insert into E_CENS_ANY_2 ( IDE_CENS, ANYS, NOMBREVOTACIONSASSOCIADES) 
                  values (v_idcens,(SELECT EXTRACT (YEAR FROM DATAINICI) FROM VOTACIO WHERE IDVOTACIO=V_IDVOTACIO),1);
               end if;              
               
               END IF;
               
       
            
             IF procediment='BAIXAVOTACIO_CENS' THEN 
             
               UPDATE E_CENS_ANY_2 SET NOMBREVOTACIONSASSOCIADES=NOMBREVOTACIONSASSOCIADES-1
               WHERE IDE_CENS =v_idcens AND
                     ANYS= (SELECT EXTRACT (YEAR FROM DATAINICI) FROM VOTACIO WHERE IDVOTACIO=V_IDVOTACIO);
               
               
            END IF;
            
          
             IF procediment='ACTUALITZARPERCVOTACIONS' THEN 
            
               V_PERCENTATGE_ANTERIOR :=0;     
               
               
             --CALCULEM I ACTULITZEM ELS VALORS UN A UN PER A UNA MAJOR CLAREDAT
             --OBTENCIO DE L'ANY AFECTAT
            
               SELECT EXTRACT (YEAR FROM DATAINICI),PArTICIPACIO INTO V_ANYO,V_PERCENTATGE_VOTACIO_ACTUAL FROM VOTACIO WHERE IDVOTACIO=V_IDVOTACIO;
             
            --VOTACIO AMB MAJOR PARTICIPACIO   
          
               -- verifiquem l'existencia de la fila
               SELECT COUNT (*)  INTO V_HAYFILA FROM E_ANYS WHERE ANYO = V_ANYO  ;
               
               IF V_HAYFILA = 0 THEN
               --si encara no hi ha fila la creem 
               insert into E_ANYS (  ANYO) 
                  values (v_ANYO);
               end if;
              -- cerquem la participacio de l'any
               SELECT VOTACIOMAJORPARTICIP INTO V_IDVOTACIOMAJORP FROM E_ANYS WHERE ANYO = V_ANYO  ;
               IF   V_IDVOTACIOMAJORP <> 0 THEN
                    SELECT PARTICIPACIO INTO V_PERCENTATGE_ANTERIOR FROM VOTACIO WHERE  IDVOTACIO=V_IDVOTACIOMAJORP;
               END IF;      
               -- si es major que la que teniem la canviem.
               
               IF V_PERCENTATGE_ANTERIOR < V_PERCENTATGE_VOTACIO_ACTUAL THEN
               UPDATE E_ANYS SET VOTACIOMAJORPARTICIP= V_IDVOTACIO
               WHERE  ANYO= V_ANYO;
               END IF;        
                        
                        
            --LOCALITAT EUROPEA QUE MES VOTS HAN EMES ELS CIUTADANS
            
                SELECT NOMLOCALITAT  INTO V_LOCALITAT_MES_VOTADA FROM
                   ( SELECT NOMLOCALITAT, COUNT(*)
                      FROM CENSATS_VOTACIO_CENS CV, CENSATS CE, VOTACIO V
                      WHERE 
                        CV.CENSATS_IDCODI_ALEATORI=CE.IDCODI_ALEATORI AND
                        CV.IDCENSATS_VOTACIO=V.IDVOTACIO AND
                      EXTRACT (YEAR FROM DATAINICI) =  V_ANYO
                      GROUP BY NOMLOCALITAT
                      ORDER BY 2 DESC
                    )
              
                WHERE ROWNUM =1;
              
                UPDATE E_ANYS SET POBLACIOMESVOTS= V_LOCALITAT_MES_VOTADA
                WHERE  ANYO= V_ANYO;
                
                
           --PERCENTATGE DE CIUTADANS QUE MAI HAN VOTAT
                
                --ciutadans unics en les votacions de l'any
                
                    SELECT COUNT(DISTINCT CENSATS_IDCODI_ALEATORI)INTO V_CIUTADANS_ANY
                 FROM  VOTACIO V, CENSATS_VOTACIO_CENS CV
                 WHERE 
                 CV.IDCENSATS_VOTACIO= V.IDVOTACIO AND
                 EXTRACT (YEAR FROM DATAINICI) =  V_ANYO;
                
                
                --ciutadans unics en les votacions de l'any, que han votat                
                
                 SELECT COUNT(DISTINCT CENSATS_IDCODI_ALEATORI)INTO V_CIUTADANS_ANY_SI
                 FROM  VOTACIO V, CENSATS_VOTACIO_CENS CV
                 WHERE 
                 CV.IDCENSATS_VOTACIO= V.IDVOTACIO AND
                 CV.HAVOTAT='SI' AND
                 EXTRACT (YEAR FROM DATAINICI) =  V_ANYO;
                
                
                --actualitzacio taula E_ANYS
                
                   UPDATE E_ANYS SET CIUTADANSNOHANVOTAT= 
                   (V_CIUTADANS_ANY-V_CIUTADANS_ANY_SI)*100 /V_CIUTADANS_ANY
                   WHERE  ANYO= V_ANYO;
                
                
         
             -- VOTACIO HISTORICA AMB MAJOR PARTICIPACIO
         
        UPDATE E_GLOBAL SET MAJORPARTICIPACIO = ( SELECT IDVOTACIO FROM
      ( select IDVOTACIO, PARTICIPACIO FROM VOTACIO
             ORDER BY 2 DESC)
              WHERE ROWNUM =1);
         
                
                
        --VOTACIO HISTORICA AMB MES DIFERENCIA PERCENTUAL ENTRE OPCIONS
        
        UPDATE E_GLOBAL SET MAJORDIFOPCIONS = (
        SELECT IDVOTACIO FROM (

      SELECT  (PERC_MESVOTADA-PERC_MENYSVOTADA) AS DIFERENCIA, IDVOTACIO  FROM VOTACIO
      WHERE (PERC_MESVOTADA-PERC_MENYSVOTADA) IS NOT NULL

      ORDER BY DIFERENCIA DESC )

      WHERE ROWNUM =1);


      
              
        --VOTACIO HISTORICA AMB MENYS DIFERENCIA PERCENTUAL ENTRE OPCIONS
        
        UPDATE E_GLOBAL SET MENORDIFOPCIONS = (
        SELECT IDVOTACIO FROM (

            SELECT  (PERC_MESVOTADA-PERC_MENYSVOTADA) AS DIFERENCIA, IDVOTACIO  FROM VOTACIO
            WHERE (PERC_MESVOTADA-PERC_MENYSVOTADA) IS NOT NULL

            ORDER BY DIFERENCIA ASC )

            WHERE ROWNUM =1);



      --NOMBRE MAXIM DE VOTACIONS EN QUE HA PARTICIPAT UNA PERSONA I EL SEU PAIS

      select codipaisiso, votacions_persona  into V_ESTAT, V_VOTACIONS_PERSONA from(

        select censats_idcodi_aleatori, codipaisiso, count(*) as votacions_persona from (

        select distinct cv.censats_idcodi_aleatori, cs.codipaisiso, cv.idcensats_votacio from  censats_votacio_cens cv,
        censats cs
        where 
          cv.censats_idcodi_aleatori = cs.idcodi_aleatori AND
          HAVOTAT='SI'
         )
      group by censats_idcodi_aleatori, codipaisiso
      order by 3 desc )

      where rownum =1;


    UPDATE E_GLOBAL SET ESTAT_PERSONA=V_ESTAT, MAXIMVOTACIONS=V_VOTACIONS_PERSONA;
                
        END IF;      
            
          
        rsp:='OK';  
        COMMIT;
            
        EXCEPTION
            WHEN OTHERS THEN 
            rsp:='Error:'||SQLERRM;
            ROLLBACK;
        END;

    END;                          
/

