/
 
REM MARIAJOSE LL_VOTACIONSMENORDIFERENCIA

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."LL_VOTACIONSMENORDIFERENCIA" (v_cursor OUT SYS_REFCURSOR, RSP OUT VARCHAR2)as

    textLog VARCHAR2(255 CHAR);
    BEGIN

        BEGIN
            -- Obrir cursor 
            OPEN v_cursor FOR 
               select  TITOLVOTACIO, DATAINICI, DATAFI, 
              OPCIOMAX , VOTSMAXRESPECTETOTAL ,
              OPCIOMIN , VOTSMINRESPECTETOTAL ,
              DIFERENCIAMIN
  
FROM (

select V.TITOLVOTACIO, V.DATAINICI, V.DATAFI, 
  VO.OPCIO AS OPCIOMAX , VO.VOTSRESPECTETOTAL AS VOTSMAXRESPECTETOTAL ,
  V1.OPCIO AS OPCIOMIN, V1.VOTSRESPECTETOTAL  AS VOTSMINRESPECTETOTAL,
  VO.VOTSRESPECTETOTAL - V1.VOTSRESPECTETOTAL as DIFERENCIAMIN
  
FROM VOTACIO V , VOTACIO_OPCIO VO , VOTACIO_OPCIO V1

WHERE V.IDVOTACIO = VO.VOTACIO_IDVOTACIO 
    and V.IDVOTACIO = V1.VOTACIO_IDVOTACIO
    and VO.OPCIO = OPCIO_MESVOTADA
    and V1.OPCIO = OPCIO_MENYSVOTADA
Order by 8 ASC )

WHERE ROWNUM < 11
;
                  
            RSP:='OK';
            
        EXCEPTION
            WHEN OTHERS THEN 
                rsp:='Error:'||SQLERRM;
        END;
            -- anotar a la taula de log
        textLog:=('sense paràmetres');
         insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp  );
     
    END;
/
 
REM MARIAJOSE LL_CENS_CIUTADA

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."LL_CENS_CIUTADA" (v_idcodi_aleatori in number, 
                                                      v_cursor OUT SYS_REFCURSOR, RSP OUT VARCHAR2)as

    textLog VARCHAR2(255 CHAR);
    BEGIN

        BEGIN
            -- Obrir cursor 
            OPEN v_cursor FOR 
               select   TIPUSDECENS, ESTAT, REGIO, POBLACIO
  

              FROM CENS_HAS_CENSATS CH, CENS CS

              WHERE v_idcodi_aleatori= CH.CENSATS_IDCODI_ALEATORI and 
                    CH.CENS_IDCENS = CS.IDCENS
   
    order by  ESTAT desc, REGIO desc, POBLACIO desc
;
                  
            RSP:='OK';
            
        EXCEPTION
            WHEN OTHERS THEN 
                rsp:='Error:'||SQLERRM;
        END;
            -- anotar a la taula de log
        textLog:=('paràmetre d''entrada =' ||v_idcodi_aleatori);
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp  );
     
    END;
/
  
REM MARIAJOSE LL_VOTACIONS_CIUTADA

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."LL_VOTACIONS_CIUTADA" (v_idcodi_aleatori in number, 
                                                      v_cursor OUT SYS_REFCURSOR, RSP OUT VARCHAR2)as

    textLog VARCHAR2(255 CHAR);
    BEGIN

        BEGIN
            -- Obrir cursor 
            OPEN v_cursor FOR 
               select   TITOLVOTACIO, HAVOTAT
  

              FROM CENSATS_VOTACIO_CENS CV, VOTACIO V
                 WHERE v_idcodi_aleatori= CV.CENSATS_IDCODI_ALEATORI and 
                    CV.IDCENSATS_VOTACIO = V.IDVOTACIO 

   
    order by  HAVOTAT, TITOLVOTACIO 
;
                  
            RSP:='OK';
            
        EXCEPTION
            WHEN OTHERS THEN 
                rsp:='Error:'||SQLERRM;
        END;
            -- anotar a la taula de log
        textLog:=('paràmetre d''entrada =' ||v_idcodi_aleatori);
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp  );
     
    END;
/

REM MARIAJOSE LL_VOTACIONSMAJORDIFERENCIA

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."LL_VOTACIONSMAJORDIFERENCIA" (v_cursor OUT SYS_REFCURSOR, RSP OUT VARCHAR2)as

    textLog VARCHAR2(255 CHAR);
    BEGIN

        BEGIN
            -- Obrir cursor 
            OPEN v_cursor FOR 
               select  TITOLVOTACIO, DATAINICI, DATAFI, 
  OPCIOMAX , VOTSMAXRESPECTETOTAL ,
  OPCIOMIN , VOTSMINRESPECTETOTAL ,
  DIFERENCIA
  
FROM (

select V.TITOLVOTACIO, V.DATAINICI, V.DATAFI, 
  VO.OPCIO AS OPCIOMAX , VO.VOTSRESPECTETOTAL AS VOTSMAXRESPECTETOTAL ,
  V1.OPCIO AS OPCIOMIN, V1.VOTSRESPECTETOTAL  AS VOTSMINRESPECTETOTAL,
  VO.VOTSRESPECTETOTAL - V1.VOTSRESPECTETOTAL as DIFERENCIA
  
FROM VOTACIO V , VOTACIO_OPCIO VO , VOTACIO_OPCIO V1

WHERE V.IDVOTACIO = VO.VOTACIO_IDVOTACIO 
    and V.IDVOTACIO = V1.VOTACIO_IDVOTACIO
    and VO.OPCIO = OPCIO_MESVOTADA
    and V1.OPCIO = OPCIO_MENYSVOTADA
Order by 8 desc )

WHERE ROWNUM < 11
;
                  
            RSP:='OK';
            
        EXCEPTION
            WHEN OTHERS THEN 
                rsp:='Error:'||SQLERRM;
        END;
            -- anotar a la taula de log
        textLog:=('sense paràmetres');
         insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp  );
     
    END;
/
  
REM MARIAJOSE TOTAL_VOTACIONSPAIS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."TOTAL_VOTACIONSPAIS" (pais IN VARCHAR2, 
                          v_cursor2 OUT SYS_REFCURSOR, 
                          RSP OUT VARCHAR2) as

    textLog VARCHAR2(255 CHAR);
    BEGIN
      BEGIN
            -- Obrir cursor 
            OPEN v_cursor2 FOR 
               select  TITOLVOTACIO, DATAINICI, DATAFI, 
                NOMBREVOTANTS , ESTATVOTACIO, PARTICIPACIO, OPCIOGUANYADORA, PERCGUANYADOR
  
FROM (
select v.titolvotacio, v.datainici, v.datafi, v.nombrepersonescapacitatvot AS NOMBREVOTANTS, 
v.ESTATVOTACIO as ESTATVOTACIO, 
  cast (v.participacio as  varchar2(255)) AS PARTICIPACIO, 
     cast (v.opcio_mesvotada as  varchar2(255)) AS opcioguanyadora, 
     cast ( v.perc_mesvotada as  varchar2(255)) AS PERCguanyador
from   votacio V
  where v.idvotacio  IN (select idvotacio 
    from votacio V1, votacio_cens VC, cens CE
  where v1.idvotacio= vc.votacio_idvotacio and
        vc.censassociat= ce.idcens and
        (ce.tipusdecens='global' or (ce.tipusdecens='estatal' and 
        ce.estat=pais)) and
        v1.ESTATVOTACIO= 'finalitzada' )       
UNION
select v.titolvotacio, v.datainici, v.datafi, v.nombrepersonescapacitatvot AS NOMBREVOTANTS, 
v.ESTATVOTACIO as ESTATVOTACIO, 
         '-' AS PARTICIPACIO ,  '-' AS opcioguanyadora, '-' AS PERCguanyador
from   votacio V
  where v.idvotacio  IN (select idvotacio 
    from votacio V, votacio_cens VC, cens CE
  where v.idvotacio= vc.votacio_idvotacio and
        vc.censassociat= ce.idcens and
        (ce.tipusdecens='global' or (ce.tipusdecens='estatal' and 
        ce.estat=pais)) and
        v.ESTATVOTACIO <> 'finalitzada')
        
)
order by 2 ;
 
              RSP:='OK';
            
        EXCEPTION
            WHEN OTHERS THEN 
                rsp:='Error:'||SQLERRM;
        END;
            -- anotar a la taula de log
        textLog:=('paràmetre d''entrada = ' || pais );
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp  );
     
  
END;  
  
