

 
REM MARIAJOSE ALTAVOTACIO

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."ALTAVOTACIO" 
(titol IN VARCHAR2, dataInici IN DATE, dataFi IN DATE, dataPublicacio IN DATE, nomPresident IN VARCHAR2, adreçaWeb IN VARCHAR2, 
                    codivotacio OUT int, rsp OUT VARCHAR2) AS
                    textLog VARCHAR2(255 CHAR);
BEGIN
  begin

  insert into  votacio (idvotacio,titolvotacio,datainici,datapublicacio,nompresidenttaulaelectoral,
                        adrecawebinfo,datafi, 
                        NOMBREPERSONESCAPACITATVOT, 
                        VOTSTOTALSEMESOS,
                        PARTICIPACIO,
                        estatVotacio
                        )
              values (seq_votacio.nextval,titol,dataInici , dataPublicacio , nomPresident, adreçaWeb, datafi, 0,0,0, 'no iniciada');
              
 
select max(idvotacio) into codivotacio from votacio;

rsp:='OK';
COMMIT;

 EXCEPTION
            WHEN DUP_VAL_ON_INDEX THEN
                rsp:= ('Error intern :codi votacio ja existeix');
                ROLLBACK; 
                
        
          
            WHEN OTHERS THEN 
            IF SQLCODE=-2290 THEN
                      rsp:='Error: data fi menor que data inici';
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
        END;    
        
 
-- anotar a la taula de log
        textLog:=('titol=' || titol || ', dataInici='|| dataInici || ', datapublicacio=' || datapublicacio ||
        ', nompresident=' ||nomPresident || ', dataFi='|| datafi ); 
       insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp || ', codi votacio = ' || codivotacio);
       
-- imprimir sortida per debug
        
 --        DBMS_OUTPUT.PUT_LINE ( $$plsql_unit || ' ' || rsp || ' ' || codivotacio || ' ' ||  textLog  ); 
        
        END;

 


/
 
REM MARIAJOSE MODIFICAVOTACIO

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."MODIFICAVOTACIO" 
(v_IDENTIFICADOR IN VARCHAR2,v_titol IN VARCHAR2, v_dataInici IN DATE, v_dataFi IN DATE, v_dataPublicacio IN DATE, v_nomPresident IN VARCHAR2, 
      v_adreçaWeb IN VARCHAR2, v_estatVotacio IN VARCHAR2, rsp OUT VARCHAR2) AS
      textLog VARCHAR2(255 CHAR);
      VOTACIO_NO_TROBADA EXCEPTION;
BEGIN
 BEGIN
  UPDATE  votacio 
      SET 
      titolvotacio = v_titol,
      datainici = v_dataInici , 
      datapublicacio = v_dataPublicacio ,
      nompresidenttaulaelectoral = v_nomPresident,
      adrecawebinfo = v_adreçaWeb, 
      datafi = v_dataFi,
      estatVotacio= v_estatVotacio
               WHERE idvotacio = v_IDENTIFICADOR;
      IF sql%rowcount = 0 then raise VOTACIO_NO_TROBADA;
      
    
      end if;
      
      GESTIO_ESTADISTICA($$plsql_unit,v_IDENTIFICADOR,null,rsp);         
   

  rsp:='OK';
COMMIT;


 EXCEPTION
 

  when VOTACIO_NO_TROBADA then
    rsp:= ('ERROR:VOTACIO_NO_TROBADA : La votacio NO existeix');
      ROLLBACK;
       
      
          
            WHEN OTHERS THEN 
            IF SQLCODE=-2290 THEN
                      rsp:='Error: data fi menor que data inici';
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
        END;    
-- anotar a la taula de log
        textLog:=('idvotacio=' || v_IDENTIFICADOR || 'titol=' || v_titol || ', dataInici='|| v_dataInici || ', datapublicacio=' || v_datapublicacio ||
        ', nompresident=' ||v_nomPresident || ', adreçaWeb=' || v_adreçaWeb || ', dataFi='||v_datafi ); 
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
  
-- imprimir sortida per debug  
--  DBMS_OUTPUT.PUT_LINE ( $$plsql_unit || ' ' ||rsp || ' ' ||textLog );

     
   commit;    
        END;


REM MARIAJOSE BAIXAVOTACIO

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."BAIXAVOTACIO" 
(IDENTIFICADOR IN INT, rsp OUT VARCHAR2) AS
 textLog VARCHAR2(255 CHAR);
 VOTACIO_NO_TROBADA EXCEPTION;
 
BEGIN
  begin
  DELETE FROM VOTACIO where (idVotacio= identificador) ;
   IF sql%rowcount = 0 then raise VOTACIO_NO_TROBADA;
      end if;
   
  rsp:='OK';
COMMIT;

exception
  when VOTACIO_NO_TROBADA then
    rsp:= ('ERROR:VOTACIO_NO_TROBADA : La votacio NO existeix');
      ROLLBACK;
       
  when others then
     rsp:='Error:'||SQLERRM;
       ROLLBACK;
       
 END;    
 -- anotar a la taula de log
        textLog:=('identificador= ' || identificador ); 
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );

-- imprimir sortida per debug
 --   DBMS_OUTPUT.PUT_LINE ( $$plsql_unit|| ' ' || rsp || ' ' || textLog);
end;
/
 
REM MARIAJOSE ALTACENS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."ALTACENS" 
(estat in VARCHAR2, regio in VARCHAR2, poblacio in VARCHAR2, tipusDeCens in VARCHAR2
                  , codiCens out int, rsp OUT VARCHAR2) AS
                    textLog VARCHAR2(255 CHAR);
  tipus_Cens_Null EXCEPTION;
  Cens_GLOBAL_AMB_DADES EXCEPTION;
  tipus_Cens_Invalid EXCEPTION;
  Cens_estatal_incorrecte EXCEPTION;
  Cens_regional_incorrecte EXCEPTION;
  Cens_local_incorrecte EXCEPTION;
   
BEGIN
  begin
  if tipusDeCens is null then raise tipus_Cens_Null; end if;
  
      CASE   tipusDeCens 
      WHEN 'global' THEN   if estat is NOT null OR regio is NOT null OR poblacio is NOT null  then raise Cens_GLOBAL_AMB_DADES; end if;
      WHEN 'estatal' THEN   if estat is null OR regio is NOT null OR poblacio is NOT null  then raise Cens_estatal_incorrecte; end if;
      WHEN 'regional' THEN   if estat is null OR regio is null OR poblacio is NOT null  then raise Cens_regional_incorrecte; end if;
      WHEN 'local' THEN   if estat is null OR regio is null OR poblacio is null  then raise Cens_local_incorrecte; end if;
 
      ELSE  raise tipus_Cens_Invalid;
  
    END case;


  
  
  insert into  cens (idcens,estat,regio,poblacio,tipusDeCens
                        )
              values (seq_cens.nextval,estat,regio , poblacio , tipusDeCens);
              
 
select max(idcens) into codiCens from cens;

rsp:='OK';
COMMIT;

 EXCEPTION
            WHEN DUP_VAL_ON_INDEX THEN
                rsp:= ('Error intern :codi cens ja existeix');
                ROLLBACK; 
             
            WHEN tipus_Cens_Null THEN
                rsp:= ('Error: tipus de cens no informat');
                ROLLBACK;    
            WHEN Cens_GLOBAL_AMB_DADES THEN
                rsp:= ('Error: cens global no admet mes dades');
                ROLLBACK;    
                
            WHEN Cens_estatal_incorrecte THEN
                rsp:= ('Error: cens estatal unicament admet Estat');
                ROLLBACK;    
                     
            WHEN Cens_regional_incorrecte THEN
                rsp:= ('Error: cens regional unicament admet Estat i Regio');
                ROLLBACK;    
                 
            WHEN Cens_local_incorrecte THEN
                rsp:= ('Error: cens local no admet valors nulls, s''ha d''informar: estat, regio i localitat');
                ROLLBACK;    
                
                
           WHEN tipus_Cens_Invalid THEN
                rsp:= ('Error: tipus de cens invalid, cens entrat: ' || tipusDeCens || ', valors possibles: global, estatal, regional i local' );
                ROLLBACK;    
           
          
            WHEN OTHERS THEN 
             IF SQLCODE=-2291 THEN
                      rsp:='Error: Codi Pais ISO no trobat, el codi Pais donat es= ' ||estat ;
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF; 
  
  
  
                
        END;    
-- anotar a la taula de log
        textLog:=('estat=' || estat || ', regio='|| regio || ', poblacio=' || poblacio ||
        ', tipusDeCens=' ||tipusDeCens); 
        
      insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp || ', codi cens = ' || codicens);

-- imprimir sortida per debug       
--  DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' ' || rsp||' ' ||codicens ||' ' ||textLog );
  
      
        END;
/
 
REM MARIAJOSE BAIXACENS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."BAIXACENS" 
(IDENTIFICADOR IN INT, rsp OUT VARCHAR2) AS
 textLog VARCHAR2(255 CHAR);
 cens_NO_TROBAt EXCEPTION;
 
BEGIN
begin
  DELETE FROM cens where (idcens= identificador) ;
   IF sql%rowcount = 0 then raise cens_NO_TROBAt;
      end if;
   
  rsp:='OK';
COMMIT;

exception
  when cens_NO_TROBAt then
    rsp:= ('ERROR:cens_NO_TROBAt : El cens NO existeix');
      ROLLBACK;
       
  when others then
     rsp:='Error:'||SQLERRM;
       ROLLBACK;
       
 END;    
 -- anotar a la taula de log
        textLog:=('identificador= ' || identificador ); 
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
-- imprimir sortida per debug   
--    DBMS_OUTPUT.PUT_LINE ( $$plsql_unit || ' ' || rsp || ' ' || textLog); 
end;
/
 
REM MARIAJOSE MODIFICACIOCENS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."MODIFICACIOCENS" 

  (v_IDENTIFICADOR IN int, v_regio IN VARCHAR2, v_poblacio IN VARCHAR2,
                        rsp OUT VARCHAR2) AS
      textLog VARCHAR2(255 CHAR);
      v_tipusdecens VARCHAR2(45 CHAR);
      cens_NO_TROBAt EXCEPTION;
      Cens_regional_incorrecte EXCEPTION;
      Cens_local_incorrecte EXCEPTION;
      Cens_GLOBAL_NO_modificable EXCEPTION;   
      Cens_estatal_NO_modificable EXCEPTION;
      tipus_Cens_Invalid EXCEPTION;
        
      
      
      
BEGIN
 BEGIN
 select tipusDeCens into v_tipusdecens from cens where idCens = v_IDENTIFICADOR;
  IF sql%rowcount = 0 then raise cens_NO_TROBAt;
      end if;
      
      CASE   v_tipusdecens 
      WHEN 'global' THEN    raise Cens_GLOBAL_NO_modificable; 
      WHEN 'estatal' THEN    raise Cens_estatal_NO_modificable; 
      WHEN 'regional' THEN   if v_regio is null OR v_poblacio is NOT null  then raise Cens_regional_incorrecte; end if;
      WHEN 'local' THEN   if v_regio is null OR v_poblacio is null  then raise Cens_local_incorrecte; end if;
 
      ELSE  raise tipus_Cens_Invalid;
  
    END case;

      
 UPDATE  cens 
      SET 
     
      regio = v_regio, 
      poblacio = v_poblacio
  
              WHERE idCens = v_IDENTIFICADOR;
               
      IF sql%rowcount = 0 then raise cens_NO_TROBAt;
      end if;
   
  rsp:='OK';
COMMIT;


 EXCEPTION
 

  when cens_NO_TROBAt then
    rsp:= ('ERROR:cens_NO_TROBAt : El cens NO existeix');
      ROLLBACK;
    
           WHEN Cens_GLOBAL_NO_modificable THEN
                rsp:= ('Error: cens global no admet modificacions');
                ROLLBACK;    
                
            WHEN Cens_estatal_NO_modificable THEN
                rsp:= ('Error: cens estatal no admet modificacions');
                ROLLBACK;    
                     
            WHEN Cens_regional_incorrecte THEN
                rsp:= ('Error: modificacio cens regional unicament admet Regio');
                ROLLBACK;    
                 
            WHEN Cens_local_incorrecte THEN
                rsp:= ('Error: modificacio cens local no admet valors nulls, s''ha d''informar: regio i localitat');
                ROLLBACK;    
                
                
           WHEN tipus_Cens_Invalid THEN
                rsp:= ('Error intern: tipus de cens invalid, cens trobat: ' || v_tipusdecens || ', valors possibles: global, estatal, regional i local' );
                ROLLBACK;    
           
    
            WHEN OTHERS THEN 
                     rsp:='Error:'||SQLERRM;
                    ROLLBACK;
        END;    
        
        
-- anotar a la taula de log
        textLog:=( 'v_IDENTIFICADOR=' ||v_IDENTIFICADOR|| ', Regio='|| v_regio || ', Poblacio=' ||v_poblacio 
        ); 
         insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
-- imprimir sortida per debug            
 --           DBMS_OUTPUT.PUT_LINE ( $$plsql_unit || ' ' ||rsp || ' ' ||textLog );     
        END;


/
 
REM MARIAJOSE ALTACENSATS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."ALTACENSATS" 

(EDAT in INT, CODIPAIS in varchar2, NOMREGIO in VARCHAR2, nomlocalitat in  VARCHAR2,
                       codicensats out int, rsp out varchar2) AS
                      textLog VARCHAR2(255 CHAR);
 v_idcens int;
 
BEGIN
  begin

codicensats:= DBMS_RANDOM.VALUE*10000000000;

  insert into  censats (IDCODI_ALEATORI,EDAT,CODIPAISiso,NOMREGIO,nomlocalitat)

  values (codicensats,EDAT,CODIPAIS , NOMREGIO , nomlocalitat);
  
select idcens into v_idcens from cens where tipusdecens='global';

insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, codicensats); 

select idcens into v_idcens from cens where tipusdecens='estatal' and estat=CODIPAIS;
insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, codicensats); 

select idcens into v_idcens from cens where tipusdecens='regional' and estat=CODIPAIS and regio=NOMREGIO;
insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, codicensats); 

select idcens into v_idcens from cens where tipusdecens='local' and estat=CODIPAIS and regio=NOMREGIO and poblacio=nomlocalitat;
insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, codicensats); 

rsp:='OK';



COMMIT;

 EXCEPTION
            WHEN DUP_VAL_ON_INDEX THEN
                rsp:= ('Error intern :codi aleatori ja existeix');
                ROLLBACK; 
             WHEN NO_DATA_FOUND THEN
                rsp:= ('Error intern :algun CENS no existeix');
                  ROLLBACK;                 
        
          
            WHEN OTHERS THEN 
             IF SQLCODE=-2291 THEN
                      rsp:='Error: Codi Pais ISO no trobat, el codi Pais donat es= ' ||CODIPAIS ;
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
        END;    
        
-- anotar a la taula de log
        textLog:=( 'EDAT='|| EDAT || ', codi pais=' || CODIPAIS ||
        ', regio=' ||NOMREGIO || ', localitat='|| nomlocalitat ); 
 
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp || ', codi censats = ' || codicensats);

-- imprimir sortida per debug    
--  DBMS_OUTPUT.PUT_LINE ( $$plsql_unit || ' ' || rsp || ' ' || codicensats || ' ' ||  textLog  ); 
      
       
END;
/
 
REM MARIAJOSE OPCIO_MES_I_MENYS_VOTADA

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."OPCIO_MES_I_MENYS_VOTADA" 
(V_VOTACIO_IDVOTACIO IN NUMBER, OPCIOMESVOTADA OUT VARCHAR2,PERCMESVOTADA OUT FLOAT, OPCIOMENYSVOTADA OUT VARCHAR2, PERCMENYSVOTADA OUT FLOAT ) AS
BEGIN

 DECLARE
         CURSOR OPCIOMAX IS SELECT OPCIO,VOTSRESPECTETOTAL FROM VOTACIO_OPCIO 
                                       WHERE  VOTACIO_IDVOTACIO=V_VOTACIO_IDVOTACIO
                                              ORDER BY VOTSRESPECTETOTAL DESC;
                cursRow OPCIOMAX%ROWTYPE;
                
                BEGIN
                    OPEN opciomax;
                  
                        FETCH opcioMAX INTO cursRow;
                        
                  OPCIOMESVOTADA := CURSROW.opcio;   
                  PERCMESVOTADA := CURSROW.VOTSRESPECTETOTAL;   
               
                END;


 DECLARE
         CURSOR OPCIOMin IS SELECT OPCIO,VOTSRESPECTETOTAL FROM VOTACIO_OPCIO 
                                       WHERE  VOTACIO_IDVOTACIO=V_VOTACIO_IDVOTACIO
                                              ORDER BY VOTSRESPECTETOTAL asc;
                cursRow OPCIOMIN%ROWTYPE;
                
                BEGIN
                    OPEN opciomIN;
                 
                        FETCH opcioMIN INTO cursRow;
                        
                  OPCIOMEnySVOTADA := CURSROW.opcio;   
                  PERCMENYSVOTADA := CURSROW.VOTSRESPECTETOTAL;   
                 
                END;


END;
/
 
REM MARIAJOSE ALTAVOTACIO_CENS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."ALTAVOTACIO_CENS" (v_idvotacio IN int,  v_censassociat IN number, 
                   rsp OUT VARCHAR2) AS
                  textLog VARCHAR2(255 CHAR);


BEGIN
  begin
  
   
  insert into  VOTACIO_CENS (votacio_idvotacio,censassociat)
                        
              values (v_idvotacio, v_censassociat);
              
 
  insert into censats_votacio_cens (censats_idcodi_aleatori,IDCENSATS_VOTACIO,idcens) select censats_idcodi_aleatori,v_idvotacio,v_censassociat from cens_has_censats where cens_idcens = v_censassociat;

update VOTACIO set
  NOMBREPERSONESCAPACITATVOT = (select count(*)from censats_votacio_cens WHERE IDCENSATS_VOTACIO= v_idvotacio )
  WHERE IDVOTACIO= v_idvotacio;

   GESTIO_ESTADISTICA($$plsql_unit,v_idvotacio,  v_censassociat,  rsp);         
   


rsp:='OK';
COMMIT;

 EXCEPTION
            WHEN DUP_VAL_ON_INDEX THEN
                rsp:= ('Error intern :el cens associat ja existeix per aquesta votacio');
                ROLLBACK; 
                
        
          
            WHEN OTHERS THEN 
            IF SQLCODE=-2291 THEN
                      rsp:='Error: Codi Votacio no trobat, el codi votacio donat es= ' ||v_idvotacio ;
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
        END;    
        
        
        
-- anotar a la taula de log
        textLog:=('v_idvotacio=' || v_idvotacio || ', v_censassociat='|| v_censassociat ); 
         insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp);
 
 -- imprimir sortida per debug   
 --  DBMS_OUTPUT.PUT_LINE ($$plsql_unit || ' ' || rsp || ' ' ||  textLog  ); 
       
        END;

 


/
 
REM MARIAJOSE ALTAVOTACIOOPCIO

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."ALTAVOTACIOOPCIO" 

  
(v_idvotacio IN int,  v_opcio IN VARCHAR2, 
                   rsp OUT VARCHAR2) AS
                    textLog VARCHAR2(255 CHAR);
BEGIN
  begin

  insert into  votacio_opcio (votacio_idvotacio,nombrevotsopcio,votsrespectetotal,opcio
                        )
              values (v_idvotacio, 0 , 0 , v_opcio);
 

rsp:='OK';
COMMIT;

 EXCEPTION
            WHEN DUP_VAL_ON_INDEX THEN
                rsp:= ('Error intern :opcio ja existeix per aquesta votacio');
                ROLLBACK; 
                
        
          
            WHEN OTHERS THEN 
            IF SQLCODE=-2291 THEN
                      rsp:='Error: Codi Votacio no trobat, el codi votacio donat es= ' ||v_idvotacio ;
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
        END;    
        
        
        
-- anotar a la taula de log
        textLog:=('v_idvotacio=' || v_idvotacio || ', v_opcio='|| v_opcio ); 

        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp);
       
 -- imprimir sortida per debug         
 --       DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' '  ||rsp ||' ' || textLog ); 
        END;

 


/
 
REM MARIAJOSE MODIFICAVOTACIOOPCIO

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."MODIFICAVOTACIOOPCIO" (v_idvotacio IN int,  v_opcio IN VARCHAR2, v_nombrevotsopcio in int,
                   rsp OUT VARCHAR2
                    ) AS
      textLog VARCHAR2(255 CHAR);
      VOTACIOopcio_NO_TROBADA EXCEPTION;
      NONBREVOTSINVALID EXCEPTION;
BEGIN
 BEGIN
 if v_nombrevotsopcio < 0 then rAISE NONBREVOTSINVALID; end if;
  UPDATE  votacio_opcio 
      SET 
      
      nombrevotsopcio = v_nombrevotsopcio
      
                WHERE votacio_idvotacio = v_idvotacio and
      opcio = v_opcio ;
               
      IF sql%rowcount = 0 then raise VOTACIOopcio_NO_TROBADA;
      end if;
      
ACTUALITZARPERCVOTACIONS(v_idvotacio);
  
  rsp:='OK';
COMMIT;


 EXCEPTION
 

  when VOTACIOopcio_NO_TROBADA then
    rsp:= ('ERROR: L''opcio de la  votacio NO existeix');
      ROLLBACK;
       
  when NONBREVOTSINVALID then
  
    rsp:= ('ERROR: nombre de vots invalid');
      ROLLBACK;
      
          
            WHEN OTHERS THEN 
            IF SQLCODE=-2290 THEN
                      rsp:='Error: data fi menor que data inici';
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
        END;    
        
        
-- anotar a la taula de log
  textLog:=('v_idvotacio=' || v_idvotacio || ', v_opcio='|| v_opcio || ', v_nombrevotsopcio= ' || v_nombrevotsopcio ); 
        
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp);
     
 -- imprimir sortida per debug         
 --       DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' '  ||rsp ||' ' || textLog ); 
       
   commit;    
        END;

/
 
REM MARIAJOSE BAIXAVOTACIO_CENS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."BAIXAVOTACIO_CENS" (v_idvotacio IN int,  v_censassociat IN number, rsp OUT VARCHAR2) AS
 textLog VARCHAR2(255 CHAR);
 VOTACIO_CENS_NO_TROBADA EXCEPTION;
 
BEGIN
  begin
  DELETE FROM VOTACIO_CENS where votacio_idvotacio = v_idvotacio and
      censassociat = v_censassociat ;
   IF sql%rowcount = 0 then raise VOTACIO_CENS_NO_TROBADA;
      end if;
/* la taula censats votacio cens s'esborra per cascade */
/* actualitzem la taula de votacio amb el total de votants */ 


update VOTACIO set
  NOMBREPERSONESCAPACITATVOT = (select count(*)from censats_votacio_cens WHERE IDCENSATS_VOTACIO= v_idvotacio )
  WHERE IDVOTACIO= v_idvotacio;
 
    GESTIO_ESTADISTICA($$plsql_unit,v_idvotacio,  v_censassociat,  rsp);         
  
  rsp:='OK';
COMMIT;

exception
  when VOTACIO_CENS_NO_TROBADA then
    rsp:= ('ERROR:El cens i/o la votacio NO existeix');
      ROLLBACK;
       
  when others then
     rsp:='Error:'||SQLERRM;
       ROLLBACK;
       
 END;    
 -- anotar a la taula de log
         textLog:=('v_idvotacio=' || v_idvotacio || ', v_censassociat='|| v_censassociat||', Resultat = ' || rsp );
                insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
 -- imprimir sortida per debug         
 --       DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' '  ||rsp ||' ' || textLog );  
end;
/
 
REM MARIAJOSE BAIXAVOTACIOOPCIO

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."BAIXAVOTACIOOPCIO" (v_idvotacio IN int,  v_opcio IN VARCHAR2, rsp OUT VARCHAR2) AS
 textLog VARCHAR2(255 CHAR);
 VOTACIOOPCIO_NO_TROBADA EXCEPTION;
 
BEGIN
  begin
  DELETE FROM VOTACIO_OPCIO where votacio_idvotacio = v_idvotacio and
      opcio = v_opcio ;
   IF sql%rowcount = 0 then raise VOTACIOOPCIO_NO_TROBADA;
      end if;
      
  ACTUALITZARPERCVOTACIONS(v_idvotacio);
  
  rsp:='OK';
COMMIT;

exception
  when VOTACIOOPCIO_NO_TROBADA then
    rsp:= ('ERROR:L''opcio de la votacio NO existeix');
      ROLLBACK;
       
  when others then
     rsp:='Error:'||SQLERRM;
       ROLLBACK;
       
 END;    
 -- anotar a la taula de log
         textLog:=('v_idvotacio=' || v_idvotacio || ', v_opcio='|| v_opcio||', Resultat = ' || rsp );
                insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
 
  -- imprimir sortida per debug         
  --      DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' '  ||rsp ||' ' || textLog ); 

end;
/
 
REM MARIAJOSE ACTUALITZARPERCVOTACIONS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."ACTUALITZARPERCVOTACIONS" (v_idvotacio IN int) AS
OPCIOMESVOTADA VARCHAR2(255 CHAR);
OPCIOMENYSVOTADA VARCHAR2(255 CHAR);
VOTOSPARTICIPACION NUMBER;
PERCMESVOTADA NUMBER;
PERCMENYSVOTADA NUMBER;
RSP VARCHAR2(255 CHAR);

BEGIN
 
  select sum (nombrevotsopcio) into  VOTOSPARTICIPACION from VOTACIO_OPCIO WHERE votacio_idvotacio = v_idvotacio;
  
  update  VOTACIO_OPCIO set 
votsrespectetotal = nombrevotsopcio*100 / 

(select sum (nombrevotsopcio)  from VOTACIO_OPCIO WHERE votacio_idvotacio = v_idvotacio) 

  WHERE votacio_idvotacio = v_idvotacio;


OPCIO_MES_I_MENYS_VOTADA (v_idvotacio, OPCIOMESVOTADA,PERCMESVOTADA,OPCIOMENYSVOTADA,PERCMENYSVOTADA);

 update VOTACIO set
   OPCIO_MESVOTADA = OPCIOMESVOTADA,
   OPCIO_MENYSVOTADA = OPCIOMENYSVOTADA,
   perc_mesvotada = PERCMESVOTADA,
   perc_menysvotada = PERCMEnySVOTADA ,
     PARTICIPACIO = VOTOSPARTICIPACION * 100  /  nombrepersonescapacitatvot 
  WHERE idvotacio = v_idvotacio;
 
       GESTIO_ESTADISTICA($$plsql_unit,v_idvotacio,null,rsp);       

 END;
/
 
REM MARIAJOSE BAIXACENSATS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."BAIXACENSATS" 
          
(v_idcodi_aleatori IN number, rsp OUT VARCHAR2) AS
 textLog VARCHAR2(255 CHAR);
 censat_NO_TROBAt EXCEPTION;
 
BEGIN
begin
  DELETE FROM censats where (idcodi_aleatori= v_idcodi_aleatori) ;
  
   IF sql%rowcount = 0 then raise censat_NO_TROBAt;
      end if;
   
  rsp:='OK';
  
  
COMMIT;

exception
  when censat_NO_TROBAt then
    rsp:= ('ERROR:censat_NO_TROBAt : censat NO trobat a la base de dades');
      ROLLBACK;
       
  when others then
     rsp:='Error:'||SQLERRM;
       ROLLBACK;
       
 END;    
 -- anotar a la taula de log
        textLog:=('v_idcodi_aleatori= ' || v_idcodi_aleatori ); 
        insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
       
  -- imprimir sortida per debug         
  --      DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' '  ||rsp ||' ' || textLog ); 
end;
/
 
REM MARIAJOSE MODIFICACIOCENSATS

  CREATE OR REPLACE PROCEDURE "MARIAJOSE"."MODIFICACIOCENSATS" 
  (v_IDENTIFICADOR IN number, v_EDAT in INT, v_CODIPAIS in varchar2, v_NOMREGIO in VARCHAR2, v_nomlocalitat in  VARCHAR2,
                        rsp out varchar2) AS
      textLog VARCHAR2(255 CHAR);
       v_idcens int;
    
      censat_NO_TROBAt EXCEPTION;
   
      
      
BEGIN
 BEGIN

      
 UPDATE  censats 
      SET 
     EDAT=v_EDAT,
     CODIPAISISO=v_CODIPAIS,
     nomregio = v_NOMREGIO, 
     nomlocalitat = v_nomlocalitat
  
              WHERE idCodi_aleatori = v_IDENTIFICADOR;
               
      IF sql%rowcount = 0 then raise censat_NO_TROBAt;
      end if;

DELETE FROM CENS_HAS_CENSATS WHERE CENSATS_idcodi_aleatori = v_IDENTIFICADOR;

select idcens into v_idcens from cens where tipusdecens='global';

insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, v_IDENTIFICADOR); 

select idcens into v_idcens from cens where tipusdecens='estatal' and estat=v_CODIPAIS;

insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, v_IDENTIFICADOR); 

select idcens into v_idcens from cens where tipusdecens='regional' and estat=v_CODIPAIS and regio=v_NOMREGIO;

insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, v_IDENTIFICADOR); 

select idcens into v_idcens from cens where tipusdecens='local' and estat=v_CODIPAIS and regio=v_NOMREGIO and poblacio=v_nomlocalitat;

insert into cens_has_censats (cens_idcens, censats_idcodi_aleatori) values (v_idcens, v_IDENTIFICADOR); 

   
  rsp:='OK';
COMMIT;


 EXCEPTION
 

  when censat_NO_TROBAt then
    rsp:= ('ERROR:censat_NO_TROBAt : censat NO trobat');
      ROLLBACK;
     WHEN NO_DATA_FOUND THEN
                rsp:= ('Error intern :algun CENS no existeix');
                  ROLLBACK;                 
        
          
            WHEN OTHERS THEN 
             IF SQLCODE=-2291 THEN
                      rsp:='Error: Codi Pais ISO no trobat, el codi Pais donat es= ' ||v_CODIPAIS ;
                    ROLLBACK;
                ELSE
                    rsp:='Error:'||SQLERRM;
                    ROLLBACK;
                END IF;
                end;
        
        
-- anotar a la taula de log
        textLog:=( 'v_IDENTIFICADOR=' ||v_IDENTIFICADOR|| ', EDAT= '||v_EDAT|| ', CODIPAIS=' ||v_CODIPAIS|| ', NOMREGIO= ' || v_NOMREGIO|| ',nomlocalitat= ' || v_nomlocalitat
        ); 
         insert_log($$plsql_unit, textLog, 'Resultat = ' || rsp );
  -- imprimir sortida per debug         
  --      DBMS_OUTPUT.PUT_LINE ( $$plsql_unit ||' '  ||rsp ||' ' || textLog );        
        END;


/


