
REM MARIAJOSE SEQ_VOTACIO

   CREATE SEQUENCE  "MARIAJOSE"."SEQ_VOTACIO"  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER  NOCYCLE ;
 
REM MARIAJOSE SEQ_LOG

   CREATE SEQUENCE  "MARIAJOSE"."SEQ_LOG"  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 181 CACHE 20 NOORDER  NOCYCLE ;
 
REM MARIAJOSE SEQ_CENS

   CREATE SEQUENCE  "MARIAJOSE"."SEQ_CENS"  MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER  NOCYCLE ;
 

 
REM MARIAJOSE CENS

  CREATE TABLE "MARIAJOSE"."CENS" 
   (	"IDCENS" NUMBER(*,0) NOT NULL ENABLE, 
	"ESTAT" VARCHAR2(2), 
	"REGIO" VARCHAR2(45), 
	"POBLACIO" VARCHAR2(45), 
	"TIPUSDECENS" VARCHAR2(45) NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."CENS" ADD PRIMARY KEY ("IDCENS") ENABLE;
  ALTER TABLE "MARIAJOSE"."CENS" ADD CONSTRAINT "ESTAT" FOREIGN KEY ("ESTAT")
	  REFERENCES "MARIAJOSE"."CODIS_ISO_PAIS" ("COD_ISO") ENABLE;
 
REM MARIAJOSE CENS_INDEX1

  CREATE UNIQUE INDEX "MARIAJOSE"."CENS_INDEX1" ON "MARIAJOSE"."CENS" ("ESTAT", "REGIO", "POBLACIO") 
  ;
 
REM MARIAJOSE CENSATS

  CREATE TABLE "MARIAJOSE"."CENSATS" 
   (	"IDCODI_ALEATORI" NUMBER(*,0) NOT NULL ENABLE, 
	"EDAT" NUMBER(*,0) NOT NULL ENABLE, 
	"CODIPAISISO" VARCHAR2(2) NOT NULL ENABLE, 
	"NOMREGIO" VARCHAR2(45), 
	"NOMLOCALITAT" VARCHAR2(45)
   ) ;
  ALTER TABLE "MARIAJOSE"."CENSATS" ADD PRIMARY KEY ("IDCODI_ALEATORI") ENABLE;
  ALTER TABLE "MARIAJOSE"."CENSATS" ADD CONSTRAINT "CODIPAIS" FOREIGN KEY ("CODIPAISISO")
	  REFERENCES "MARIAJOSE"."CODIS_ISO_PAIS" ("COD_ISO") ENABLE;
 
REM MARIAJOSE CENSATS_VOTACIO_CENS

  CREATE TABLE "MARIAJOSE"."CENSATS_VOTACIO_CENS" 
   (	"IDCENSATS_VOTACIO" NUMBER(*,0) NOT NULL ENABLE, 
	"HAVOTAT" VARCHAR2(45) DEFAULT 'NO', 
	"CENSATS_IDCODI_ALEATORI" NUMBER(*,0) NOT NULL ENABLE, 
	"IDCENS" NUMBER NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."CENSATS_VOTACIO_CENS" ADD PRIMARY KEY ("IDCENSATS_VOTACIO", "CENSATS_IDCODI_ALEATORI", "IDCENS") ENABLE;
  ALTER TABLE "MARIAJOSE"."CENSATS_VOTACIO_CENS" ADD CONSTRAINT "IDVOTACIO" FOREIGN KEY ("IDCENS", "IDCENSATS_VOTACIO")
	  REFERENCES "MARIAJOSE"."VOTACIO_CENS" ("CENSASSOCIAT", "VOTACIO_IDVOTACIO") ON DELETE CASCADE ENABLE;
  ALTER TABLE "MARIAJOSE"."CENSATS_VOTACIO_CENS" ADD CONSTRAINT "CODIALEATORIVOTANT" FOREIGN KEY ("CENSATS_IDCODI_ALEATORI")
	  REFERENCES "MARIAJOSE"."CENSATS" ("IDCODI_ALEATORI") ENABLE;
 
REM MARIAJOSE PROVA2

  CREATE INDEX "MARIAJOSE"."PROVA2" ON "MARIAJOSE"."CENSATS_VOTACIO_CENS" ("CENSATS_IDCODI_ALEATORI") 
  ;
 
REM MARIAJOSE CENS_HAS_CENSATS

  CREATE TABLE "MARIAJOSE"."CENS_HAS_CENSATS" 
   (	"CENS_IDCENS" NUMBER(*,0) NOT NULL ENABLE, 
	"CENSATS_IDCODI_ALEATORI" NUMBER(*,0) NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."CENS_HAS_CENSATS" ADD PRIMARY KEY ("CENS_IDCENS", "CENSATS_IDCODI_ALEATORI") ENABLE;
  ALTER TABLE "MARIAJOSE"."CENS_HAS_CENSATS" ADD CONSTRAINT "PROVA5" FOREIGN KEY ("CENS_IDCENS")
	  REFERENCES "MARIAJOSE"."CENS" ("IDCENS") ENABLE;
  ALTER TABLE "MARIAJOSE"."CENS_HAS_CENSATS" ADD CONSTRAINT "PROVA4" FOREIGN KEY ("CENSATS_IDCODI_ALEATORI")
	  REFERENCES "MARIAJOSE"."CENSATS" ("IDCODI_ALEATORI") ON DELETE CASCADE ENABLE;
 
REM MARIAJOSE PROVA4

  CREATE INDEX "MARIAJOSE"."PROVA4" ON "MARIAJOSE"."CENS_HAS_CENSATS" ("CENSATS_IDCODI_ALEATORI") 
  ;
 
REM MARIAJOSE PROVA5

  CREATE INDEX "MARIAJOSE"."PROVA5" ON "MARIAJOSE"."CENS_HAS_CENSATS" ("CENS_IDCENS") 
  ;
 
REM MARIAJOSE CODIS_ISO_PAIS

  CREATE TABLE "MARIAJOSE"."CODIS_ISO_PAIS" 
   (	"COD_ISO" VARCHAR2(2) NOT NULL ENABLE, 
	"NOMPAIS" VARCHAR2(4000) NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."CODIS_ISO_PAIS" ADD CONSTRAINT "CODIS_ISO_PAIS_PK" PRIMARY KEY ("COD_ISO") ENABLE;
 
REM MARIAJOSE E_ANYS

  CREATE TABLE "MARIAJOSE"."E_ANYS" 
   (	"ANYO" NUMBER(*,0) NOT NULL ENABLE, 
	"VOTACIOMAJORPARTICIP" VARCHAR2(45) DEFAULT 0 NOT NULL ENABLE, 
	"POBLACIOMESVOTS" VARCHAR2(45) DEFAULT 0 NOT NULL ENABLE, 
	"CIUTADANSNOHANVOTAT" FLOAT(126) DEFAULT 0 NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."E_ANYS" ADD PRIMARY KEY ("ANYO") ENABLE;
 
REM MARIAJOSE E_CENS_ANY

  CREATE TABLE "MARIAJOSE"."E_CENS_ANY" 
   (	"IDE_CENS" NUMBER(*,0) NOT NULL ENABLE, 
	"ANYS" NUMBER(*,0) DEFAULT 0 NOT NULL ENABLE, 
	"VALORMIGPARTICIP" FLOAT(126) DEFAULT 0 NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."E_CENS_ANY" ADD CONSTRAINT "E_CENS_ANY_PK" PRIMARY KEY ("IDE_CENS", "ANYS") ENABLE;
 
REM MARIAJOSE E_CENS_ANY_2

  CREATE TABLE "MARIAJOSE"."E_CENS_ANY_2" 
   (	"IDE_CENS" NUMBER(*,0) NOT NULL ENABLE, 
	"ANYS" NUMBER(*,0) NOT NULL ENABLE, 
	"NOMBREVOTACIONSASSOCIADES" VARCHAR2(45) DEFAULT 0 NOT NULL ENABLE
   ) ;
 
REM MARIAJOSE E_GLOBAL

  CREATE TABLE "MARIAJOSE"."E_GLOBAL" 
   (	"IDE_GLOBAL" NUMBER(*,0) DEFAULT 0 NOT NULL ENABLE, 
	"MAJORPARTICIPACIO" NUMBER DEFAULT 0, 
	"MAJORDIFOPCIONS" NUMBER DEFAULT 0 NOT NULL ENABLE, 
	"MENORDIFOPCIONS" NUMBER DEFAULT 0 NOT NULL ENABLE, 
	"MAXIMVOTACIONS" NUMBER(*,0) DEFAULT 0 NOT NULL ENABLE, 
	"ESTAT_PERSONA" VARCHAR2(2)
   ) ;
  ALTER TABLE "MARIAJOSE"."E_GLOBAL" ADD PRIMARY KEY ("IDE_GLOBAL") ENABLE;
 
REM MARIAJOSE E_VOTACIONS_ANY_PAIS

  CREATE TABLE "MARIAJOSE"."E_VOTACIONS_ANY_PAIS" 
   (	"ANYS" NUMBER(*,0) NOT NULL ENABLE, 
	"CODIPAISISO" VARCHAR2(2) NOT NULL ENABLE, 
	"NOMBREVOTACIONSFINALITZADES" NUMBER(*,0)
   ) ;
  ALTER TABLE "MARIAJOSE"."E_VOTACIONS_ANY_PAIS" ADD CONSTRAINT "E_VOTACIONS_ANY_PAIS_PK" PRIMARY KEY ("ANYS", "CODIPAISISO") ENABLE;
 
REM MARIAJOSE LOGS

  CREATE TABLE "MARIAJOSE"."LOGS" 
   (	"IDLOGS" NUMBER(*,0) NOT NULL ENABLE, 
	"PROCEDIMENT" VARCHAR2(45) NOT NULL ENABLE, 
	"DATALOG" TIMESTAMP (6) DEFAULT current_timestamp NOT NULL ENABLE, 
	"PARAMENTRADA" VARCHAR2(255), 
	"PARAMSORTIDA" VARCHAR2(255), 
	"USUARI" VARCHAR2(45)
   ) ;
  ALTER TABLE "MARIAJOSE"."LOGS" ADD PRIMARY KEY ("IDLOGS") ENABLE;
 
REM MARIAJOSE INCREMENT_LOG

  CREATE OR REPLACE TRIGGER "MARIAJOSE"."INCREMENT_LOG" BEFORE INSERT ON LOGS 
FOR EACH ROW 
BEGIN
    SELECT seq_LOG.NEXTVAL INTO :NEW.IDLOGs
    FROM DUAL;
END INCREMENT_LOG;
/
ALTER TRIGGER "MARIAJOSE"."INCREMENT_LOG" ENABLE;
 
REM MARIAJOSE VOTACIO

  CREATE TABLE "MARIAJOSE"."VOTACIO" 
   (	"IDVOTACIO" NUMBER(*,0) NOT NULL ENABLE, 
	"TITOLVOTACIO" VARCHAR2(45) NOT NULL ENABLE, 
	"DATAINICI" DATE NOT NULL ENABLE, 
	"DATAPUBLICACIO" DATE NOT NULL ENABLE, 
	"NOMPRESIDENTTAULAELECTORAL" VARCHAR2(45) NOT NULL ENABLE, 
	"ADRECAWEBINFO" VARCHAR2(45), 
	"NOMBREPERSONESCAPACITATVOT" NUMBER(*,0) DEFAULT 0 NOT NULL ENABLE, 
	"VOTSTOTALSEMESOS" NUMBER(*,0) NOT NULL ENABLE, 
	"PARTICIPACIO" FLOAT(126) NOT NULL ENABLE, 
	"ESTATVOTACIO" VARCHAR2(45), 
	"DATAFI" DATE NOT NULL ENABLE, 
	"OPCIO_MESVOTADA" VARCHAR2(4000), 
	"OPCIO_MENYSVOTADA" VARCHAR2(4000), 
	"PERC_MESVOTADA" FLOAT(126), 
	"PERC_MENYSVOTADA" FLOAT(126)
   ) ;
  ALTER TABLE "MARIAJOSE"."VOTACIO" ADD PRIMARY KEY ("IDVOTACIO") ENABLE;
  ALTER TABLE "MARIAJOSE"."VOTACIO" ADD CONSTRAINT "VOTACIO_CHK1" CHECK (
dataInici <= dataFi
) ENABLE;
 
REM MARIAJOSE VOTACIO_CENS

  CREATE TABLE "MARIAJOSE"."VOTACIO_CENS" 
   (	"VOTACIO_IDVOTACIO" NUMBER(*,0) NOT NULL ENABLE, 
	"CENSASSOCIAT" NUMBER NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."VOTACIO_CENS" ADD PRIMARY KEY ("CENSASSOCIAT", "VOTACIO_IDVOTACIO") ENABLE;
  ALTER TABLE "MARIAJOSE"."VOTACIO_CENS" ADD CONSTRAINT "PROVA" FOREIGN KEY ("VOTACIO_IDVOTACIO")
	  REFERENCES "MARIAJOSE"."VOTACIO" ("IDVOTACIO") ENABLE;
  ALTER TABLE "MARIAJOSE"."VOTACIO_CENS" ADD CONSTRAINT "CENSASSOCIAT" FOREIGN KEY ("CENSASSOCIAT")
	  REFERENCES "MARIAJOSE"."CENS" ("IDCENS") ENABLE;
 
REM MARIAJOSE PROVA

  CREATE INDEX "MARIAJOSE"."PROVA" ON "MARIAJOSE"."VOTACIO_CENS" ("VOTACIO_IDVOTACIO") 
  ;
 
REM MARIAJOSE VOTACIO_OPCIO

  CREATE TABLE "MARIAJOSE"."VOTACIO_OPCIO" 
   (	"NOMBREVOTSOPCIO" NUMBER(*,0), 
	"VOTSRESPECTETOTAL" FLOAT(126), 
	"OPCIO" VARCHAR2(45) NOT NULL ENABLE, 
	"VOTACIO_IDVOTACIO" NUMBER(*,0) NOT NULL ENABLE
   ) ;
  ALTER TABLE "MARIAJOSE"."VOTACIO_OPCIO" ADD PRIMARY KEY ("VOTACIO_IDVOTACIO", "OPCIO") ENABLE;
  ALTER TABLE "MARIAJOSE"."VOTACIO_OPCIO" ADD CONSTRAINT "PROVA1" FOREIGN KEY ("VOTACIO_IDVOTACIO")
	  REFERENCES "MARIAJOSE"."VOTACIO" ("IDVOTACIO") ENABLE;
 
REM MARIAJOSE PROVA1

  CREATE INDEX "MARIAJOSE"."PROVA1" ON "MARIAJOSE"."VOTACIO_OPCIO" ("VOTACIO_IDVOTACIO") 
  ;
 


